unit Cut;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, IniFiles,CutFile;


type
    TCut=class(TObject)
    public
        procedure Create(Parent:TCutFile;Section:string);
        procedure DoCut;

        function GetRect(): TRect;

    private
        _Parent:TCutFile;
	    _FileName:string;
        _CutRect:TRect;
    end;

implementation


function TCut.GetRect(): TRect;
begin
	Result:=_CutRect;
end;


procedure TCut.Create(Parent:CutFile.TCutFile;Section:string);
var
    IniFile:TIniFile;
begin
    _Parent:=Parent;

    IniFile:=TIniFile.Create(_Parent.IniFileName);
    _FileName:=_Parent.OutputFolder + IniFile.ReadString(Section,'FileName','');

    _CutRect.Left:=IniFile.ReadInteger(Section,'PosX',0);
    _CutRect.Top:=IniFile.ReadInteger(Section,'PosY',0);
    _CutRect.Right:=IniFile.ReadInteger(Section,'SizeX',0)+_CutRect.Left;
    _CutRect.Bottom:=IniFile.ReadInteger(Section,'SizeY',0)+_CutRect.Top;

    IniFile.Free;
end;


procedure TCut.DoCut;
var
    Bmp:TBitmap;
    DestRect:TRect;
begin
    Bmp:=TBitmap.Create;
    DestRect.Left:=0;
    DestRect.Top:=0;
    DestRect.Right:=_CutRect.Right-_CutRect.Left;
    DestRect.Bottom:=_CutRect.Bottom-_CutRect.Top;

    Bmp.Width:=DestRect.Right;
    Bmp.Height:=DestRect.Bottom;
    Bmp.Canvas.CopyRect(DestRect,_Parent.Canvas,_CutRect);
    Bmp.SaveToFile(_FileName);
    Bmp.Free;
end;


end.
