{
Copyright 2000 (c) Aurlien GATEAU aka Bug*Killer
aurelien.gateau@mail.dotcom.fr

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}
unit DocView;

interface

uses classes;

type
	TDVMsg=longint;

	IView = interface
		procedure OnDocMessage(Msg:TDVMsg);
	end;

	TDoc = class(TObject)
	protected
		ViewList:TList;
	public
		constructor Create;
		destructor Destroy; override;
		procedure AddView(View:IView);
		procedure RemoveView(View:IView);
		procedure SendMessage(Msg:TDVMsg);
	end;

implementation


{

TDoc constructor

}
constructor TDoc.Create;
begin
	inherited Create;
	ViewList:=TList.Create;
end;


{

TDoc destructor

}
destructor TDoc.Destroy;
begin
	ViewList.Free;
	inherited Destroy;
end;


{

TDoc.AddView
Adds a new view to the doc

}
procedure TDoc.AddView(View:IView);
begin
	ViewList.Add(Pointer(View));
end;


{

TDoc.RemoveView
Removes a view from the doc
Does nothing if the view was not added

}
procedure TDoc.RemoveView(View:IView);
var
	NumView:integer;
begin
	NumView:=ViewList.IndexOf(@View);
	if NumView>-1 then
		ViewList.Delete(NumView);
end;


{

TDoc.SendMessage
Sends a message to the views

}
procedure TDoc.SendMessage(Msg:TDVMsg);
var
	NumView:Integer;
	View:IView;
begin
	for NumView:=0 to ViewList.Count-1 do
	begin
		View:=IView(ViewList[NumView]);
		View.OnDocMessage(Msg);
	end;

end;

end.
